// HitTesterView.cpp : implementation of the CHitTesterView class
//

#include "stdafx.h"
#include "HitTester.h"

#include "HitTesterDoc.h"
#include "HitTesterView.h"
#include ".\hittesterview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CHitTesterView

IMPLEMENT_DYNCREATE(CHitTesterView, CView)

BEGIN_MESSAGE_MAP(CHitTesterView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_COMMAND(ID_LINE_CURVED, OnLineCurved)
	ON_UPDATE_COMMAND_UI(ID_LINE_CURVED, OnUpdateLineCurved)
	ON_COMMAND(ID_LINE_STRAIGHT, OnLineStraight)
	ON_UPDATE_COMMAND_UI(ID_LINE_STRAIGHT, OnUpdateLineStraight)
	ON_COMMAND(ID_SELECT_NODE, OnSelectNode)
	ON_UPDATE_COMMAND_UI(ID_SELECT_NODE, OnUpdateSelectNode)
	ON_COMMAND(ID_SELECT_SEGMENT, OnSelectSegment)
	ON_UPDATE_COMMAND_UI(ID_SELECT_SEGMENT, OnUpdateSelectSegment)
	ON_COMMAND(ID_VIEW_SHOWNODE, OnViewShownode)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SHOWNODE, OnUpdateViewShownode)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_COMMAND(ID_DRAW_DELETE, OnDrawDelete)
	ON_UPDATE_COMMAND_UI(ID_DRAW_DELETE, OnUpdateDrawDelete)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
END_MESSAGE_MAP()

// CHitTesterView construction/destruction

CHitTesterView::CHitTesterView()
{
	// TODO: add construction code here
	m_bDrawMode = FALSE;
	m_bDrawBegin = FALSE;
	m_bDrawLine = FALSE;
	m_bDrawCurve = FALSE;

	m_bSelectMode = FALSE;
	m_bSelectNode = FALSE;
	m_bSelectSegment = FALSE;

	m_bShowNode = TRUE;

	m_obArray = new CHCN_ObjectArray();
	m_ptArray = new CHCN_ObjectArray();

	m_colorStroke = Color(255,0,0,0);
	m_rStrokeWidth = 1;
	m_Bitmap = NULL;
}

CHitTesterView::~CHitTesterView()
{
	if(!m_obArray->IsEmpty()) m_obArray->RemoveAll();
	m_obArray = NULL;

	if(!m_ptArray->IsEmpty()) m_ptArray->RemoveAll();
	m_ptArray = NULL;
}

BOOL CHitTesterView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CHitTesterView drawing

void CHitTesterView::OnDraw(CDC* pDC)
{
	CHitTesterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here
	if(m_obArray->GetSize() > 0)
	{
		CRect rect;
		GetClientRect(rect);
		Bitmap bmp(rect.Width(),rect.Height());
		Graphics* graph = Graphics::FromImage(&bmp);
		
		for(int i=0; i<m_obArray->GetSize(); i++)
		{
			// Get base object
			CHCN_Object* pBase = reinterpret_cast<CHCN_Object*>(m_obArray->GetAt(i));
			
			if(pBase->GetObjectType() == pBase->HCN_Line)
			{
				CHCN_ObjectLine* pLine = (CHCN_ObjectLine*)m_obArray->GetAt(i);

				// Draw object to bitmap graphics
				pLine->DrawObject(*graph);
			}
		}

		Rect rc(rect.left,rect.top,rect.Width(),rect.Height());

		// Clone the bitmap
		m_Bitmap = bmp.Clone(rc, PixelFormatDontCare);
		
		// Draw the bitmap graphics
		Graphics graphics(pDC->m_hDC);
		graphics.DrawImage(m_Bitmap, rc);
	}
}


// CHitTesterView printing

BOOL CHitTesterView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CHitTesterView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CHitTesterView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CHitTesterView diagnostics

#ifdef _DEBUG
void CHitTesterView::AssertValid() const
{
	CView::AssertValid();
}

void CHitTesterView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CHitTesterDoc* CHitTesterView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CHitTesterDoc)));
	return (CHitTesterDoc*)m_pDocument;
}
#endif //_DEBUG


// CHitTesterView message handlers

void CHitTesterView::OnLineCurved()
{
	// TODO: Add your command handler code here
	if(m_bDrawCurve)
	{
		CancelDrawingMode();
	}
	else
	{
		CancelDrawingMode();
		m_bDrawMode = TRUE;
		m_bDrawCurve = TRUE;
	}
}

void CHitTesterView::OnUpdateLineCurved(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_bDrawCurve);
}

void CHitTesterView::OnLineStraight()
{
	// TODO: Add your command handler code here

	if(m_bDrawLine)
	{
		CancelDrawingMode();
	}
	else
	{
		CancelDrawingMode();
		m_bDrawMode = TRUE;
		m_bDrawLine = TRUE;
	}
}

void CHitTesterView::OnUpdateLineStraight(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_bDrawLine);
}

void CHitTesterView::OnSelectNode()
{
	// TODO: Add your command handler code here
	if(m_bDrawMode)
		CancelDrawingMode();

	if(!m_bSelectNode)
	{
		m_bSelectMode = TRUE;
		m_bSelectNode = TRUE;
		m_bSelectSegment = FALSE;
	}
	else
		m_bSelectNode = FALSE;
}

void CHitTesterView::OnUpdateSelectNode(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(m_obArray->GetSize() > 0);
	pCmdUI->SetCheck(m_bSelectNode);
}

void CHitTesterView::OnSelectSegment()
{
	// TODO: Add your command handler code here
	if(m_bDrawMode)
		CancelDrawingMode();

	if(!m_bSelectSegment)
	{
		m_bSelectMode = TRUE;
		m_bSelectSegment = TRUE;
		m_bSelectNode = FALSE;
	}
	else
		m_bSelectSegment = FALSE;
}

void CHitTesterView::OnUpdateSelectSegment(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(m_obArray->GetSize() > 0);
	pCmdUI->SetCheck(m_bSelectSegment);
}

void CHitTesterView::OnViewShownode()
{
	// TODO: Add your command handler code here
	if(!m_bShowNode)
		m_bShowNode = TRUE;
	else
		m_bShowNode = FALSE;

	Invalidate();
}

void CHitTesterView::OnUpdateViewShownode(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_bShowNode);
}

void CHitTesterView::AddPointToArray(CPoint &point)
{
	// Save point for mouse draw
	m_pt1 = m_pt2 = point;
	GetDC()->DPtoLP(&point);
	
	// Add point to array
	CHCN_ObjectPoint* pPt = new CHCN_ObjectPoint(point);
	m_ptArray->Add(pPt);
}

void CHitTesterView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	CRect rect;
	GetClientRect(rect);

	if(rect.PtInRect(point))
	{
		if(m_bSelectMode)
		{
			// Create DC
			CDC* pDC = this->GetDC();

			VERIFY(pDC != NULL);

			if(pDC != NULL)
			{
				// Set ROP2 mode
				int nR2 = pDC->SetROP2(R2_NOTXORPEN);

				// Create pen
				CPen* newPen = new CPen(PS_SOLID|PS_GEOMETRIC, 1, RGB(255,0,255));
				CPen* pOldPen = pDC->SelectObject(newPen);

				// Run Hit Test
				for(int i=0; i<m_obArray->GetSize(); i++)
				{
					// Get base object
					CHCN_Object* pBase = m_obArray->GetObjectBaseClass(i);
					
					if(pBase->GetObjectType() == pBase->HCN_Line)
					{
						CHCN_ObjectLine* pLine = (CHCN_ObjectLine*)pBase;
						
						// Segment Selection mode
						if(m_bSelectSegment)
						{
							if(pLine->IsSegmentHit(point))
							{
								if(pLine->m_bSelected)
								{
									pLine->m_bSelected = FALSE;
									pLine->m_bShowNode = FALSE;
								}
								else
								{
									pLine->m_bSelected = TRUE;
									pLine->m_bShowNode = TRUE;
								}
							}
						}

						// Node Selection mode
						if(m_bSelectNode)
						{
							if(pLine->IsNodeHit(point))
							{
								if(pLine->m_bSelected)
								{
									pLine->m_bSelected = FALSE;
									pLine->m_bShowNode = FALSE;
								}
								else
								{
									pLine->m_bSelected = TRUE;
									pLine->m_bShowNode = TRUE;
								}
							}
						}
					}

					// Redraw
					Invalidate();
				}
			
				// Restore ROP2 mode
				VERIFY(nR2 >= 0);
				pDC->SetROP2(nR2);
				pDC->SelectObject(pOldPen);
			
				// Clean-up
				pDC->Detach();
				pDC = NULL;
				
			}
		}

		if(m_bDrawMode)
		{
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_CROSS));

			if(m_bDrawLine || m_bDrawCurve)
			{
				if(!m_bDrawBegin)
				{
					// Begin drawing
					m_bDrawBegin = TRUE;

					// Create new point array
					m_ptArray = new CHCN_ObjectArray();
				}

				// Add this point
				AddPointToArray(point);
			}
		}
	}
	CView::OnLButtonDown(nFlags, point);
}

void CHitTesterView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	CRect rect;
	GetClientRect(rect);

	if( rect.PtInRect(point))
    {
		if(m_bDrawMode)
		{	
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_CROSS));

			if(m_bDrawLine || m_bDrawCurve)
			{
				if(m_bDrawBegin)
				{
					//
				}
			}
		}
	}

	CView::OnLButtonUp(nFlags, point);
}

void CHitTesterView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	CRect rect;
	GetClientRect(rect);

	if( rect.PtInRect(point))
    {
		::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));

		if(m_bDrawMode)
		{
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_CROSS));

			if(m_bDrawBegin && (nFlags != MK_LBUTTON))
			{
				// Obtain DC
				CDC* pDC = this->GetDC();

				// Verify it
				VERIFY(pDC != NULL);

				if(pDC != NULL)
				{
					// Set ROP2 mode
					int nR2 = pDC->SetROP2(R2_NOTXORPEN);

					if(m_bDrawLine || m_bDrawCurve)
					{
						// Convert to logical point
						pDC->DPtoLP(&m_pt1);
						pDC->DPtoLP(&m_pt2);
						
						// Erase previous line
						pDC->MoveTo(m_pt1);
						pDC->LineTo(m_pt2);

						// Set point #2 to current mouse point
						m_pt2 = point;
						pDC->DPtoLP(&m_pt2);
						
						// Draw new line
						pDC->MoveTo(m_pt1);
						pDC->LineTo(m_pt2);
					}

					// Restore ROP2 mode
					VERIFY(nR2 >= 0);
					pDC->SetROP2(nR2);
				
					// Clean-up
					pDC->Detach();
					pDC = NULL;
				}
			}
		}
	}
	else
	{
		::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
	}

	CView::OnMouseMove(nFlags, point);
}

void CHitTesterView::OnRButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	CRect rect;
	GetClientRect(rect);

	if( rect.PtInRect(point))
    {
		if(m_bDrawMode)
		{
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_CROSS));

			if(m_bDrawBegin)
			{
				if(m_bDrawLine  || m_bDrawCurve)
					AddObjectLine();

				if(!m_bDrawLine || !m_bDrawCurve)
				{
					m_bDrawBegin = FALSE;	// Terminate drawing mode
					Invalidate();
				}
			}
			else
				CancelDrawingMode();
		}
	}

	CView::OnRButtonDown(nFlags, point);
}

void CHitTesterView::OnRButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	CRect rect;
	GetClientRect(rect);

	if( rect.PtInRect(point))
    {
		if(m_bDrawMode)
		{
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_CROSS));

			if(m_bDrawLine || m_bDrawCurve)
			{
				if(m_bDrawBegin)
				{
					//
				}
			}
		}
	}
	CView::OnRButtonUp(nFlags, point);
}

void CHitTesterView::OnDrawDelete()
{
	// TODO: Add your command handler code here

clean_leftover:
	for(int i=0; i<m_obArray->GetSize(); i++)
	{
		// Get base object
		CHCN_Object* pBase = m_obArray->GetObjectBaseClass(i);
		
		if(pBase->GetObjectType() == pBase->HCN_Line)
		{
			CHCN_ObjectLine* pLine = (CHCN_ObjectLine*)pBase;

			// Remove selected object
			if(pLine->m_bSelected)
			{
				m_obArray->RemoveAt(i);
				m_obArray->FreeExtra();
				pLine = NULL;
			}
		}
	}
	
	// Test for left over
	if(CountSelectedObject() > 0)
		goto clean_leftover;
	
	// Redraw
	Invalidate();
}

void CHitTesterView::OnUpdateDrawDelete(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(CountSelectedObject() > 0);
}

void CHitTesterView::AddObjectLine()
{
	if(m_ptArray->GetSize() > 1)
	{
		CHCN_ObjectLine* pLine = new CHCN_ObjectLine(m_ptArray, m_colorStroke, 1);
		pLine->m_bCurved = m_bDrawCurve;
		pLine->m_bShowNode = m_bShowNode;
		pLine->m_bSelected = FALSE;
		m_obArray->Add(pLine);
		
		// Redraw
		m_bDrawBegin = FALSE;	// Line mode end
		Invalidate();	
	}
}

void CHitTesterView::CancelDrawingMode()
{
	m_bDrawBegin = FALSE;	// Cancel draw command
	m_bDrawMode = FALSE;	// Off drawing mode
	m_bDrawLine = FALSE;
	m_bDrawCurve = FALSE;

	m_bSelectMode = FALSE;
	m_bSelectNode = FALSE;
	m_bSelectSegment = FALSE;

	Invalidate();
}

int CHitTesterView::CountSelectedObject(void)
{
	int nSelectCount = 0;

	if(m_obArray->GetSize() > 0)
	{
		for(int i=0; i<m_obArray->GetSize(); i++)
		{
			CHCN_Object* pBase = m_obArray->GetObjectBaseClass(i);
			if(pBase->GetObjectType() == pBase->HCN_Line)
			{
				CHCN_ObjectLine* pLine = (CHCN_ObjectLine*)pBase;

				if(pLine->m_bSelected)
					nSelectCount++;
			}
		}
	}
	else
		nSelectCount = 0;

	return nSelectCount;
}

void CHitTesterView::OnFileSave()
{
	// TODO: Add your command handler code here

	// Save the drawing.
	const char szFilter[] = "Image Files (*.png)|*.png|All Files (*.*)|*.*||";
	const char szExt[] = "png";

	CFileDialog* dlg = new CFileDialog(FALSE, szExt, NULL, OFN_CREATEPROMPT|OFN_OVERWRITEPROMPT, szFilter, this);

	if(dlg->DoModal() == IDOK)
	{
		CLSID pngClsid;
		GetEncoderClsid(L"image/png", &pngClsid);
		m_Bitmap->Save(dlg->GetPathName().AllocSysString(), &pngClsid, NULL);
	}
}

int CHitTesterView::GetEncoderClsid(const WCHAR* format, CLSID* pClsid)
{
   UINT  num = 0;          // number of image encoders
   UINT  size = 0;         // size of the image encoder array in bytes

   ImageCodecInfo* pImageCodecInfo = NULL;

   GetImageEncodersSize(&num, &size);
   if(size == 0)
      return -1;  // Failure

   pImageCodecInfo = (ImageCodecInfo*)(malloc(size));
   if(pImageCodecInfo == NULL)
      return -1;  // Failure

   GetImageEncoders(num, size, pImageCodecInfo);

   for(UINT j = 0; j < num; ++j)
   {
      if( wcscmp(pImageCodecInfo[j].MimeType, format) == 0 )
      {
         *pClsid = pImageCodecInfo[j].Clsid;
         free(pImageCodecInfo);
         return j;  // Success
      }    
   }

   free(pImageCodecInfo);
   return -1;  // Failure
}
